<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.1.1/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">

    <!-- bootstrap & jquery -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <script src="plugins/sweetalert2/sweetalert2.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body class="hold-transition sidebar-mini layout-fixed">
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Request Counseling</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item dropdown mr-3">
                    <a class="nav-link" data-toggle="dropdown" href="#"><i class="fa-solid fa-user-large"></i></a>
                    <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
                        <span class="dropdown-item dropdown-header" id="user-info"></span>
                        <div class="dropdown-divider"></div>
                        <div class="text-center mt-2">
                            <button class="btn btn-danger" id="btn-log-out"><i
                                    class="fa-solid fa-right-from-bracket"></i> Log out</button>
                        </div>
                    </div>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->


        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="addressMap.html" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">ADMIN Real Estates</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="info text-white ml-2" id="username-info"></div>
                </div>
                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class with font-awesome or any other icon font library -->
                        <li class="nav-item">
                            <a href="../CustomerFrontEnd/index.html" class="nav-link">
                                <i class="fa-solid fa-house-chimney-user"></i>
                                <p>
                                    HomePage
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./realestate1.html" class="nav-link">
                                <i class="fa-solid fa-city"></i>
                                <p>
                                    Thông tin BĐS
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="./requestCounseling1.html" class="nav-link active">
                                <i class="fa-solid fa-envelope"></i>
                                <p>
                                    Yêu cầu tư vấn
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Request Counseling</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->

            <!-- Main content -->
            <section class="content">
                <div class="container-fluid">
                    <h4 class="text-center form-group" id="h4-info-list">Request Counseling List</h4>
                    <div class="form-group">
                        <button class="btn btn-success" id="btn-filter-reqCounseling-status"><i
                                class="fa-solid fa-filter"></i>
                            Lọc yêu cầu chưa tư vấn</button>
                    </div>
                    <table class="table table-bordered table-striped table-hover" id="reqCounseling-table">
                        <thead>
                            <tr>
                                <th>Action</th>
                                <th>ID</th>
                                <th>Họ tên</th>
                                <th>Email</th>
                                <th>Số điện thoại</th>
                                <th>Lời nhắn</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                </div><!-- /.container-fluid -->
            </section>
            <!-- /.content -->

            <!-- Delete reqCounseling modal -->
            <div id="delete-reqCounseling-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header bg-danger">
                            <h5 class="modal-title">Delete Request Counseling Confirmation</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            Are you sure to delete this Request Counseling?
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-danger" id="btn-delete-confirm">Confirm</button>
                            <button class="btn btn-secondary" id="btn-update-cancel"
                                data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>

            <!-- Update reqCounseling modal -->
            <div id="update-reqCounseling-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header bg-primary">
                            <h5 class="modal-title">Xác nhận đã tư vấn</h5>
                            <button class="close" data-dismiss="modal">&times;</button>
                        </div>
                        <div class="modal-body">
                            Bạn chắc chắn đã tư vấn yêu cầu này?
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-success" id="btn-update-confirm">Confirm</button>
                            <button class="btn btn-secondary" id="btn-update-cancel"
                                data-dismiss="modal">Cancel</button>
                        </div>
                    </div>
                </div>
            </div>

        </div>
        <!-- /.content-wrapper -->
        <footer class="main-footer">

            <div class="float-right d-none d-sm-inline-block">
                <b>Version</b> 1.0.0
            </div>
        </footer>
    </div>

    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>

    <script>
        $(document).ready(function () {
            const token = getCookie("token");
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
            // Biến mảng toàn cục chứa danh sách tên các thuộc tính
            const gDATA_COLS = ["action", "id", "fullname", "email", "phoneNum", "message"];

            // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
            const gACTION_COL = 0;
            const gID_COL = 1;
            const gFULLNAME_COL = 2;
            const gEMAIL_COL = 3;
            const gPHONE_NUM_COL = 4;
            const gMESSAGE_COL = 5;

            var gTable = $("#reqCounseling-table").DataTable({
                columns: [
                    { data: gDATA_COLS[gACTION_COL] },
                    { data: gDATA_COLS[gID_COL] },
                    { data: gDATA_COLS[gFULLNAME_COL] },
                    { data: gDATA_COLS[gEMAIL_COL] },
                    { data: gDATA_COLS[gPHONE_NUM_COL] },
                    { data: gDATA_COLS[gMESSAGE_COL] }
                ],
                "columnDefs": [
                    {
                        "targets": gACTION_COL,
                        "defaultContent": `<button class='btn btn-primary btn-update-reqCounseling'><i class="fa-regular fa-pen-to-square"></i></button>
                            <button class='btn btn-danger btn-delete-reqCounseling'><i class="fa-regular fa-trash-can"></i></button>`
                    }
                ]
            });

            var gId;
            var gClick = 0;

            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();

            //Set sự kiện cho nút logout
            $("#btn-log-out").on("click", function () {
                redirectToLogin();
            });

            // gán sự kiện  nút lọc reqCounseling
            $("#btn-filter-reqCounseling-status").on("click", function () {
                gClick++;
                if (gClick % 2 == 0) {
                    $("#btn-filter-reqCounseling-status").html(`<i class="fa-solid fa-filter"></i> Lọc yêu cầu chưa tư vấn`);
                    $('#h4-info-list').html("Request Counseling List");
                    callApiGetAllReqCounseling();
                } else {
                    $("#btn-filter-reqCounseling-status").html("Hiển thị tất cả");
                    $('#h4-info-list').html("Danh sách yêu cầu chưa tư vấn");
                    callApiFilterReqCounseling();
                }
            });

            // gán sự kiện  nút chi tiết reqCounseling
            $("#reqCounseling-table").on("click", ".btn-update-reqCounseling", function () {
                onBtnUpdateReqCounselingClick(this);
            });

            // gán sự kiện  nút xóa reqCounseling
            $("#reqCounseling-table").on("click", ".btn-delete-reqCounseling", function () {
                onBtnDeleteReqCounselingClick(this);
            });

            // gán sự kiện cho nút confirm update
            $('#btn-update-confirm').on('click', onBtnConfirmUpdateClick);

            // gán sự kiện cho nút confirm delete
            $('#btn-delete-confirm').on('click', onBtnConfirmDeleteClick);

            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            function onPageLoading() {
                callApiGetUserIdByToken();
                callApiGetAllReqCounseling();
            }

            // Hàm xử lý khi nút chi tiết reqCounseling được nhấn
            function onBtnUpdateReqCounselingClick(paramBtnDetail) {
                "use strict";
                // B1: Thu thập dữ liệu
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramBtnDetail).parents('tr');
                // Lấy các dữ liệu của hàng có cùng hàng với nút được nhấn
                var vDataRow = gTable.row(vRowSelected).data();
                console.log(vDataRow);
                gId = vDataRow.id;
                // B2: Kiểm tra dữ liệu (bỏ qua)
                // B3: xử lý hiển thị dữ liệu vào modal
                $('#update-reqCounseling-modal').modal("show");
            }

            // Hàm xử lý khi nút delete reqCounseling được nhấn
            function onBtnDeleteReqCounselingClick(paramBtnDetail) {
                "use strict";
                // B1: Thu thập dữ liệu
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramBtnDetail).parents('tr');
                // Lấy các dữ liệu của hàng có cùng hàng với nút được nhấn
                var vDataRow = gTable.row(vRowSelected).data();
                console.log(vDataRow);
                gId = vDataRow.id;
                // B2: Kiểm tra dữ liệu (bỏ qua)
                // B3: xử lý hiển thị dữ liệu vào modal
                $('#delete-reqCounseling-modal').modal("show");
            }

            function onBtnConfirmUpdateClick() {
                callApiUpdateReqCounseling();
                $('#update-reqCounseling-modal').modal("hide");
            }

            function onBtnConfirmDeleteClick() {
                callApiDeleteReqCounseling();
                $('#delete-reqCounseling-modal').modal("hide");
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
            //Hàm get Cookie
            function getCookie(cname) {
                var name = cname + "=";
                var decodedCookie = decodeURIComponent(document.cookie);
                var ca = decodedCookie.split(';');
                for (var i = 0; i < ca.length; i++) {
                    var c = ca[i];
                    while (c.charAt(0) == ' ') {
                        c = c.substring(1);
                    }
                    if (c.indexOf(name) == 0) {
                        return c.substring(name.length, c.length);
                    }
                }
                return "";
            }

            function callApiGetUserIdByToken() {
                $.ajax({
                    url: "http://localhost:8080/findUserId/Token",
                    type: 'GET',
                    dataType: "json",
                    contentType: "application/json; charset=utf-8",
                    headers: {
                        "Authorization": "Token " + token,
                    },
                    success: function (responseObject) {
                        //console.log(responseObject);
                        callApiGetEmployeeByID(responseObject);
                    },
                    error: function (pAjaxContext) {
                        //redirectToLogin();
                    }
                });
            }

            // Hàm gọi api lấy dữ liệu employee bằng id
            function callApiGetEmployeeByID(paramEmployeeId) {
                $.ajax({
                    url: "http://localhost:8080/employees/" + paramEmployeeId,
                    method: "GET",
                    async: false,
                    success: function (paramResponseObj) {
                        //console.log(paramResponseObj);
                        handlerUserDataResponse(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            function handlerUserDataResponse(paramUserData) {
                $("#username-info").html(paramUserData.username);
                $("#user-info").html(paramUserData.username);
            }

            // Hàm gọi api lấy tất cả realEstate
            function callApiGetAllReqCounseling() {
                $.ajax({
                    url: "http://localhost:8080/reqCounseling",
                    method: "GET",
                    async: false,
                    headers: {
                        'Content-Type': 'application/json;charset=UTF-8',
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        console.log(paramResponseObj);
                        loadDataToTable(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            // Hàm load dữ liệu vào bảng
            function loadDataToTable(paramData) {
                "use strict";
                //Xóa toàn bộ dữ liệu đang có của bảng
                gTable.clear();
                //Cập nhật data cho bảng
                gTable.rows.add(paramData);
                //Cập nhật lại giao diện hiển thị bảng
                gTable.draw();
            }

            function callApiFilterReqCounseling() {
                $.ajax({
                    url: "http://localhost:8080/reqCounselingStatusN",
                    method: "GET",
                    async: false,
                    headers: {
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        console.log(paramResponseObj);
                        loadDataToTable(paramResponseObj);
                    },
                    error: function (paramError) {
                        console.log(paramError);
                        alertError("Không tìm thấy các yêu cầu chưa tư vấn.")
                    }
                });
            }

            function callApiUpdateReqCounseling() {
                $.ajax({
                    url: "http://localhost:8080/reqCounseling/" + gId,
                    method: "PUT",
                    async: false,
                    headers: {
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        console.log(paramResponseObj);
                        callApiGetAllReqCounseling();
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }

            function callApiDeleteReqCounseling() {
                $.ajax({
                    url: "http://localhost:8080/reqCounseling/" + gId,
                    method: "DELETE",
                    async: false,
                    headers: {
                        "Authorization": "Token " + token,
                    },
                    success: function (paramResponseObj) {
                        console.log(paramResponseObj);
                        callApiGetAllReqCounseling();
                    },
                    error: function (paramError) {
                        console.log(paramError);
                    }
                });
            }
        });
    </script>
</body>